<template>
<div class="body_box">
    <div class="tipTitle">受试电机监控</div>
    <div class="content_box">
        <div class="content_top">
            <p class="title_into">当前运行情况</p>
            <el-form ref="form" label-width="120px">
                <el-form-item label="受试电机状态：">
                    <el-input size="mini" v-model="formData.thisInfo.ssdjzt" style="width:65px"></el-input>
                </el-form-item>
                <!-- <el-form-item label="直流调速柜：">
                    <el-input size="mini" v-model="formData.thisInfo.zltsg" style="width:65px"></el-input>
                </el-form-item> -->

                <el-form-item label="受试侧轴联器：">
                    <el-input size="mini" v-model="formData.thisInfo.ssczlq" style="width:65px"></el-input>
                </el-form-item>
                <el-form-item label="测功侧轴联器：">
                    <el-input size="mini" v-model="formData.thisInfo.cgczlq" style="width:65px"></el-input>
                </el-form-item>
                
            </el-form>
        </div>
        <div class="content_cent">
            <p class="title_into">详细参数情况</p>
            <div class="clear"></div>
                <el-form ref="form" label-width="100px">
                    <el-col :span="12">
                        <el-form-item label="当前电压：">
                            <el-input size="mini" v-model="formData.thisInfo.dqdy" style="width:60px"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :span="10">
                        <el-form-item label="额定电压：">
                            <el-input size="mini" v-model="formData.thisInfo.eddy" style="width:60px"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-form-item label="当前电流：">
                            <el-input size="mini" v-model="formData.thisInfo.dqdl" style="width:60px"></el-input>
                        </el-form-item>
                    <el-col :span="12">
                        <el-form-item label="当前频率：">
                            <el-input size="mini" v-model="formData.thisInfo.dqpl" style="width:60px"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :span="12">
                        <el-form-item label="额定频率：">
                            <el-input size="mini" v-model="formData.thisInfo.edpl" style="width:60px"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :span="12">
                        <el-form-item label="输入功率：">
                            <el-input size="mini" v-model="formData.thisInfo.srgl" style="width:60px"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :span="12">
                        <el-form-item label="输出功率：">
                            <el-input size="mini" v-model="formData.thisInfo.scgl" style="width:60px"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-form-item label="转速：">
                            <el-input size="mini" v-model="formData.thisInfo.zs" style="width:60px"></el-input>
                        </el-form-item>
                    <el-col :span="12">
                        <el-form-item label="冷却水温度：">
                            <el-input size="mini" v-model="formData.thisInfo.lqswd" style="width:60px"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :span="12">
                        <el-form-item label="进水压力：">
                            <el-input size="mini" v-model="formData.thisInfo.jsyl" style="width:60px"></el-input>
                        </el-form-item>
                    </el-col>
                </el-form>
            <div class="clear"></div>
        </div>
        <!-- 轴承温度 -->
        <div class="content_bottom">
            <p class="title_into">定子轴承温度</p>
            <div ref="temperature" class="temperature"></div>
        </div>
    </div>
    <div class="left_Box">
        <!-- <div class="tipTitle">AFE变频驱动柜监控</div> -->
        <div class="content_cent canvs_box">
            <div class="diagram-content">
                    <div class="diagram-stc" ref="static"></div>
                    <div class="diagram-flush" ref="flush"></div>
            </div>
        </div>
        <div class="content_bottom list_box">
            <p class="title_into">报警情况</p>
            <!-- 表单 -->
            <div class="flex-page-content">
                <div class="batteryrHistoryquery" style="width: 100%;height: 100%;">
                    <el-table :data="tableData" style="width: 100%" max-height="145px"> 
                        <el-table-column prop="date" label="报警时间"></el-table-column>
                        <el-table-column prop="name" label="报警名称"></el-table-column>
                        <el-table-column prop="address" label="报警描述"></el-table-column>
                    </el-table>
                </div>
            </div>
        </div>
    </div>
    <div class="right_box">
        <p class="title_into">实时曲线</p>
        <p class="title_echarts">受试电机电压电流</p>
        <div class="echarts-right" ref="5000kvaEcharts">

        </div>
        <p class="title_echarts">受试电机输出功率</p>
        <div class="echarts-right" ref="13200kvaEcharts">

        </div>
    </div>
    <div class="clear"></div>
</div>
</template>
<script>
import getWsUrl from "@/assets/js/getWsUrl";
import * as echarts from 'echarts';
import gridCircuitDiagram from '@/pages/testedMotor/js/gridCircuitDiagram'
let diagram;
export default {
    chart: {},
    data(){
        return {
            isOpen:false,
            tableData:[],
            formData:{
                thisInfo:{
                    ssdjzt:"运行中",
                    zltsg:"运行正常",
                    ssczlq:"链接",
                    cgczlq:"断开",
                    dqdy:"500V",
                    eddy:"690V",
                    dqdl:"20A",
                    dqpl:"44.5Hz",
                    edpl:"44.5Hz",
                    srgl:"10Kw",
                    scgl:"9.6kw",
                    zs:"9r/min",
                    lqswd:"20℃",
                    jsyl:"0.5MPa"

                }
            },
            echartsList:[
                {echartsCurr:[],echartsVol:[],name:"受试电机电压电流",class:"5000kvaEcharts"},
                {echartsCurr:[],echartsVol:[],name:"受试电机输出功率",class:"13200kvaEcharts"},
            ],
            dateTime:[],
        }
    },
    components:{
        // ContentBox
    },
    mounted() {
        let self = this;
        diagram = gridCircuitDiagram(this.$refs.static, this.$refs.flush);
        self.initEcharts();
        self.openSocket();
        window.addEventListener('resize', () => {
            diagram = gridCircuitDiagram(this.$refs.static, this.$refs.flush);
            self.initEcharts();
        })
    },
    methods: {
        // 初始化图表
        initEcharts(){
            let self = this;
                self.echartsList.forEach(item => {
                    self.$options.chart[item.class] = echarts.init(self.$refs[item.class]);
                });
                self.$options.chart['temperature'] = echarts.init(self.$refs['temperature']);
                
        },
        // 打开链接
        openSocket() {
            // 初始化WebSocket
            this.close();
            this.initSocket();
        },
        // 初始化
        initSocket() {
            // 未被初始化初始化
            if (!this.isOpen) {
                const wsUri = getWsUrl("/device", "");
                this.socket = new WebSocket(wsUri);
                this.socket.onmessage = this.onMessage;
                this.socket.onopen = this.onOpen;
                this.socket.onerror = this.onError;
                this.socket.onclose = this.close;
            }
        },
        onMessage(res) {
            let self = this;
            let result = JSON.parse(res.data)
            if(result.code == 1){
                this.isOpen = true;
                // 表单赋值
                self.formData.thisInfo.cxFivePanelCurr = result.data.screenRTList[0].panelCurr + "A";
                self.echartsList[0].echartsCurr.push(result.data.screenRTList[0].panelCurr);

                self.formData.thisInfo.cxFivePanelVol = result.data.screenRTList[0].panelVol + "V";
                self.echartsList[0].echartsVol.push(result.data.screenRTList[0].panelVol);

                self.formData.thisInfo.cxOnePanelVol = result.data.screenRTList[2].panelVol + "V";
                self.echartsList[1].echartsCurr.push(result.data.screenRTList[2].panelCurr);
                self.echartsList[1].echartsVol.push(result.data.screenRTList[2].panelVol);

                self.formData.thisInfo.cxTwoPanelVol = result.data.screenRTList[3].panelVol + "V";

                self.formData.thisInfo.volA = result.data.dcMainBoard.volA + "V";
                self.formData.thisInfo.volB = result.data.dcMainBoard.volB + "V";
                self.formData.thisInfo.currA = result.data.dcMainBoard.currA + "A";
                self.formData.thisInfo.currB = result.data.dcMainBoard.currB + "A";
            }
            self.dateTime.push(self.getTime());
            if(self.dateTime.length>10){
                self.dateTime.shift();
            }
            self.echartsList.forEach(item => {
                if(item.echartsCurr.length>10){
                    item.echartsCurr.shift();
                    item.echartsVol.shift();
                }
                self.setOption(item,true);
            });
            self.setEcharts();
        },
        getTime(){
            var myDate = new Date(); //实例一个时间对象；
                // myDate.getFullYear();   //获取系统的年；
                // myDate.getMonth()+1;   //获取系统月份，由于月份是从0开始计算，所以要加1
                // myDate.getDate(); // 获取系统日，
                // myDate.getHours(); //获取系统时，
                // myDate.getMinutes(); //分
                // myDate.getSeconds(); //秒
            let thisTime = myDate.getHours() + ":" + myDate.getMinutes() + ":" + myDate.getSeconds();
            return thisTime
        },
        onOpen() {
            // 向后台发送请求数据
            // this.socket.send(this.thisLi.deviceId);
        },
        onError() {
            console.log('链接失败')
        },
        close() {
            // 关闭websocket
            if (this.isOpen) {
                // 打印关闭信息
                console.log("关闭电源实时报警WebSocket");
                this.socket.close();
            }
        },
        // 配置图表
        setOption:function(data,status){
            let self = this;
            let option = {
                    animation: false,
                    grid: {
                        left: '70',
                        top: '20',
                        right: '70',
                        bottom: '30'
                    },
                    tooltip: {
                        show: true
                    },
                    xAxis: {
                        type: 'category',
                        show: true,
                        splitLine:{
                            show:false
                        },
                        data:self.dateTime
                    },
                    yAxis: [{
                        type: 'value',
                        gridIndex:0,
                        show: true,
                        splitLine: {
                            show: false
                        },
                        minInterval: 1,
                        axisLabel: {
                            formatter: '{value}V'
                        },
                    },{
                        type: 'value',
                        gridIndex:0,
                        show: true,
                        splitLine: {
                            show: false
                        },
                        minInterval: 1,
                        axisLabel: {
                            formatter: '{value}A'
                        },
                    }],
                    series: [{
                        data: data.echartsCurr,
                        // xAxisIndex: 0,
                        yAxisIndex: 0,//使用的 y 轴的 index，在单个图表实例中存在多个 y轴的时候有用。
                        type: 'line',
                        symbol: 'none',
                        step: false,
                        smooth: true
                    },{
                        data:data.echartsVol,
                        // xAxisIndex: 0,
                        yAxisIndex: 1,//使用的 y 轴的 index，在单个图表实例中存在多个 y轴的时候有用。
                        type: 'line',
                        symbol: 'none',
                        // step: false,
                        smooth: true
                    },]
                };
                    self.$options.chart[data.class].setOption(option);
                
                
        },
        setPanelPos:function(){

        },
        // 图表
        setEcharts:function(){
            var data = [{
                    month: "1",
                    value: 30,},

                {
                    month: "2",
                    value: 45,
                },

                {
                    month: "3",
                    value: 80,
                    // ratio: 75.8
                },

                {
                    month: "4",
                    value: 60,
                    // ratio: 19.8
                },

                {
                    month: "5",
                    value: 50,
                    // ratio: 44.5
                },


                {
                    month: "6",
                    value: 70,
                    // ratio: 87.3
                },
                {
                    month: "7",
                    value: 20,
                    // ratio: 87.3
                },
                {
                    month: "8",
                    value: 20,
                    // ratio: 87.3
                },
                {
                    month: "9",
                    value: 40,
                    // ratio: 87.3
                },
                {
                    month: "10",
                    value: 60,
                    // ratio: 87.3
                },
                {
                    month: "11",
                    value: 50,
                    // ratio: 87.3
                },
                {
                    month: "12",
                    value: 60,
                    // ratio: 87.3
                },
                { month: "13",value: 60,},{ month: "14",value: 55 },{month: "15",value: 44,}];
            var bkData = [300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300, 300];
            var xData = [],
                yData = [];
            var min = 50;
            data.map(function(a, b) {
                xData.push(a.month);
                if (a.value === 0) {
                    yData.push(a.value + min);
                } else {
                    yData.push(a.value);
                }
            });
        let option = {
                backgroundColor: "#111c4e",
                color: ['#3398DB'],
                tooltip: {
                    show: true,
                    trigger: 'axis',
                    axisPointer: {
                        type: 'line',
                        lineStyle: {
                            opacity: 0
                        }
                    },
                },
                grid: {
                    left: '5%',
                    right: '5%',
                    bottom: '5%',
                    top: '7%',
                    height: '85%',
                    containLabel: true,
                    z: 22
                },
                xAxis: [{
                    type: 'category',
                    boundaryGap: true, // 坐标轴两边留白
                    gridIndex: 0,
                    data: xData,
                    axisLabel: {
                        textStyle: {
                            fontSize: 14,
                            color: '#fff'
                        }
                    },
                    axisLine: {
                        lineStyle: {
                            // color: 'rgba(255,255,255,.2)',
                        }
                    },
                    axisTick: {
                        show: false
                    },
                }],
                yAxis: [{
                        type: 'value',
                        gridIndex: 0,
                        axisTick: {
                            show: false
                        },
                        // min: min,
                        max: 300,
                        axisLine: {
                            lineStyle: {
                                // color: 'rgba(255,255,255,0)'
                            }
                        },
                        axisLabel: {
                            color: '#95a2aa',
                            fontSize: 14,
                            formatter: '{value}℃'
                        },
                        splitLine: {
                            lineStyle: {
                                color: 'rgba(255,255,255,.1)'
                            }
                        },
                    },
                ],
                series: [{
                        // name: '合格率',
                        type: 'bar',
                        barWidth: '50%',
                        xAxisIndex: 0,
                        yAxisIndex: 0,
                        itemStyle: {
                            normal: {
                                color: function(value){
                                    let  color = "rgb(255,199,28)";
                                    if(value.data >=80){
                                        color = "red";
                                    }
                                    return color;
                                }
                            }
                        },
                        data: yData,
                        zlevel: 11

                    },
                    {
                        // name: '背景',
                        type: 'bar',
                        barWidth: '50%',
                        xAxisIndex: 0,
                        yAxisIndex: 0,
                        barGap: '-100%',
                        data: bkData,
                        itemStyle: {
                            normal: {
                                color: 'rgba(255,255,255,0.1)',
                                barBorderRadius: [0, 0, 0, 0]
                            },
                        },
                        tooltip: {
                            show: false
                        },
                        zlevel: 9
                    },

                ]
            };   
            this.$options.chart['temperature'].setOption(option);
        }
    },
    destroyed(){
        this.close();
    }

}
</script>    
<style scoped>
.clear{
    clear: both;
}
.partition{
    height: 1px;
    width: 100%;
    border-bottom:1px solid #fff;
}
.temperature{
    width: 100%;
    height: 90%;
}
.batteryrHistoryquery{
    overflow: auto;
}
.echarts-right{
    width: 100%;
    height: 160px;
}
.title_echarts{
    padding: 0 0 0 20px;
    font-size: 12px;
    margin-top: 20%;
}
/deep/.el-input__inner{
    padding: 0 0.5rem;
}
/deep/.el-table th, /deep/.el-table tr{
    background: #171350 !important;
    color: #fff;
}
.body_box{
    width: 100%;
    height: 100%;
}
.left_Box,.content_box,.right_box{
    float: left;
    height: 95%;
    margin: 0 4px;
}
.content_top,.content_cent,.content_bottom{
    height: 30%;
    border:1px solid #1e9ff2;
    padding: 1%;
}
.content_top{
    height: 26%;
    margin-bottom: 1%;
}
.content_cent{
    height: 42%;
}
.content_cent{
    margin-bottom: 1%;
}
.title_into{
    padding-left: 1%;
    color: #ffff18;
}
.detail_info{
    float: left;
    width: 22%;
    margin-right: 2%;
    font-size: 12px;
    padding-top: 2%;
}
/deep/.el-form-item{
    margin-bottom:0;
}
.content_box{
    width: 26%;
    margin-left: 10px;
}
.right_box{
    width: 29%;
    border: 1px solid #1e9ff2;
}
.left_Box{
    width: 40%;
    /* padding: 0.75rem 1rem; */
}
.diagram-content{
    height: 100%;
    /* width: 100%; */
    position: relative;
}
.diagram-stc {
        width: 100%;
        /* height: 100%; */
        overflow: hidden;
    }

.diagram-flush {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    z-index: 9;
    overflow: hidden;
}
/* .diagram-stc /deep/ canvas,.diagram-flush /deep/ canvas{
    object-fit:fill !important;
} */
.canvs_box{
    height: 65%;    
}
.list_box{
    height: 33.5%;
}
</style>